unit TLWCheck;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Gerd, Global, Grids;

type
     tstatus = (ok, dbja, dbnein);
     tti = record
          id : integer;
          name : string;
          status : tstatus;
     end;
     ti = array of tti;

  TFLWCheck = class(TForm)
    liLW: TDriveComboBox;
    liVerz: TDirectoryListBox;
    G: TStringGrid;
    procedure liLWClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    lw, lwbez : string;
    ordner : ti;
  end;

var
  FLWCheck: TFLWCheck;

implementation

{$R *.DFM}

procedure TFLWCheck.liLWClick(Sender: TObject);

var
     anz, j, k : integer;
     gefunden : boolean;

begin
     lwbez := lilw.items [lilw.itemindex];
     setlength (lwbez, pred (length (lwbez)));
     lw := tsuppercase (copy (lwbez, 1, 1));
     lwbez := tsuppercase (copy (lwbez, succ (pos ('[', lwbez)), 255));
     showmessage (lw + ':   ' + lwbez);

     // Laufwerk wurde ausgewhlt
     anz := pred (liverz.items.Count);
     setlength (ordner, anz);

     for  j := 0 to anz do
     begin
          // Alle Ordner einlesen und in den Array schreiben
          ordner [j].id := 0;
          ordner [j].name := liverz.items [j];
          ordner [j].status := dbnein;
     end;

     // Alle Ordner auf Vorhandensein in der DB prfen
     for  j := 0 to anz do
     for  k := 1 to recordcount do
     begin
          lesen (k);

          if   rec.Verz = ordner [j].name then
          begin
               ordner [j].id := k;
               ordner [j].status := ok;
               break;
          end;
     end;

     g.rowcount := 2;

     for  j := 0 to anz do
     if   ordner [j].status <> ok then
     begin
          g.rowcount := succ (g.rowcount);
          g.cells [0, pred (g.rowcount)] := inttostr (ordner [j].id);
     end;
end;

end.
