unit UFBiografie;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, GLOBAL, GERD, ExtCtrls, UFBild;

type
  TFBiografie = class(TForm)
    Memo: TMemo;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    darsteller : ansistring;
  end;

var
  FBiografie: TFBiografie;

implementation

{$R *.lfm}

procedure TFBiografie.FormShow(Sender: TObject);
begin
     if   fileexists (bioverz + darsteller + '.txt')
     then memo.lines.LoadFromFile (bioverz + darsteller + '.txt');

     fbild := nil;

     if   fileexists (bildverz + darsteller + '.jpg') then
     begin
          application.createform (TFBild, FBild);
          FBild.image.Picture.LoadFromFile (bildverz + darsteller + '.jpg');
          FBild.image.Refresh;
          FBild.clientwidth := FBild.image.width;
          FBild.clientheight := FBild.image.height;
          FBild.top := 0;
          FBild.left := screen.width - FBild.width;
          FBild.show;
          left := 0;
          top := 0;
          height := screen.Height;
          width := pred (FBild.left);
     end else
     begin
          windowstate := wsmaximized;
     end;

     caption := caption + darsteller;
end;

procedure TFBiografie.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
     memo.lines.savetoFile (bioverz + darsteller + '.txt');

     if   fbild <> nil
     then fbild.free;

     if   dateigroesse (bioverz + darsteller + '.txt') = 0
     then deletefile (bioverz + darsteller + '.txt');
end;

end.

