unit UFHaupt;

interface

uses
  Messages , SysUtils , Classes , Graphics , Controls , Forms , Dialogs ,
  LCLIntf , LCLType , StdCtrls , Grids , DBGrids , gerd , global , ExtCtrls ,
  Menus , FileCtrl , DbCtrls , CheckLst , AsyncProcess , LResources ,
  LConvEncoding , UTF8Process , UFMarker , db , dbf , mysql55conn , sqldb ,
  UFKonvertierung , BufDataset , process , eventlog;

type

  { TFHaupt }

  TFHaupt = class(TForm)
    buMarkereinblendung : TButton ;
    laBemerkungx1 : TLabel ;
    laGesamtbytes : TLabel ;
    liDa : TComboBox ;
    ds: TDatasource;
    dbG: TDBGrid;
    dsdarst : TDatasource ;
    Label1: TLabel;
    quupdate : TSQLQuery ;
    qudarst : TSQLQuery ;
    grmarker : TStringGrid ;
    sqlconn: TMySQL55Connection;
    qu: TSQLQuery;
    sqltrans: TSQLTransaction;
    teSB: TEdit;
    buDateiausgabe: TButton;
    buKorrigieren: TButton;
    buLoeschen: TButton;
    Timer1: TTimer;
    tiSB: TTimer;
    GroupBox1: TGroupBox;
    laBemerkungx: TLabel;
    Label5: TLabel;
    buTXT: TButton;
    teBemerkung: TEdit;
    buInfo: TButton;
    MainMenu1: TMainMenu;
    MDatei: TMenuItem;
    MDatensicherung: TMenuItem;
    N1: TMenuItem;
    MBeenden: TMenuItem;
    MBearbeiten: TMenuItem;
    MHinzufgen: TMenuItem;
    MKorrigieren: TMenuItem;
    MLoeschen: TMenuItem;
    MFilmlisten: TMenuItem;
    N2: TMenuItem;
    MInfoDateien: TMenuItem;
    MSichern_in_Ordner: TMenuItem;
    N4: TMenuItem;
    MMarkierte_loeschen: TMenuItem;
    MDaten_importieren: TMenuItem;
    MDaten_exportieren: TMenuItem;
    OD: TOpenDialog;
    SD: TSaveDialog;
    N3: TMenuItem;
    MGesehenzaehlen: TMenuItem;
    N6: TMenuItem;
    MDarstellerliste: TMenuItem;
    MTools: TMenuItem;
    pnFilmografie: TPanel;
    pnBiografie: TPanel;
    laPosInfo: TPanel;
    cbErwSuche: TCheckBox;
    MAnzeige: TMenuItem;
    MMarker1: TMenuItem;
    MMarker2: TMenuItem;
    MMarker3: TMenuItem;
    MMarker4: TMenuItem;
    MMarker5: TMenuItem;
    MMarker6: TMenuItem;
    MMarker7: TMenuItem;
    MMarker8: TMenuItem;
    MMarker9: TMenuItem;
    MMarker10: TMenuItem;
    MNurGeloeschte: TMenuItem;
    N8: TMenuItem;
    MAktMarker: TMenuItem;
    MKeinMarker: TMenuItem;
    pnmarker: TPanel;
    liMarker: TListBox;
    Label3: TLabel;
    MGehezuCDNr: TMenuItem;
    pnTitel: TPanel;
    MMarker_loeschen: TMenuItem;
    MMarker_umhaengen: TMenuItem;
    MMloeschen1: TMenuItem;
    MMloeschen2: TMenuItem;
    MMloeschen3: TMenuItem;
    MMloeschen4: TMenuItem;
    MMloeschen5: TMenuItem;
    MMloeschen6: TMenuItem;
    MMloeschen7: TMenuItem;
    MMloeschen8: TMenuItem;
    MMloeschen9: TMenuItem;
    MMloeschen10: TMenuItem;
    LaGroesse: TLabel;
    LaOrdner: TLabel;
    N5: TMenuItem;
    MArchivumbenennen: TMenuItem;
    MLWueberpruefen: TMenuItem;
    procedure dbGTitleClick (Column : TColumn );
    procedure dsDataChange (Sender : TObject ; Field : TField );
    procedure buDateiausgabeClick(Sender: TObject);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of String);
    procedure buHinzufuegenClick(Sender: TObject);
    procedure buKorrigierenClick(Sender: TObject);
    procedure grmarkerDrawCell (Sender : TObject ; aCol , aRow : Integer ; aRect : TRect ; aState : TGridDrawState );
    procedure grmarkerResize (Sender : TObject );
    procedure grmarkerSelection (Sender : TObject ; aCol , aRow : Integer );
    procedure Timer1Timer(Sender: TObject);
    procedure tiSBTimer(Sender: TObject);
    procedure GKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure buLoeschenClick(Sender: TObject);
    procedure buTXTClick(Sender: TObject);
    procedure GDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure GDblClick(Sender: TObject);
    procedure GSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure teSBKeyPress(Sender: TObject; var Key: Char);
    procedure buInfoClick(Sender: TObject);
    procedure MBeendenClick(Sender: TObject);
    procedure MLoeschenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MDatensicherungClick(Sender: TObject);
    procedure MSichern_in_OrdnerClick(Sender: TObject);
    procedure MDateiClick(Sender: TObject);
    procedure MMarkierte_loeschenClick(Sender: TObject);
    procedure MDaten_importierenClick(Sender: TObject);
    procedure MDaten_exportierenClick(Sender: TObject);
    procedure GMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MGesehenzaehlenClick(Sender: TObject);
    procedure MDarstellerlisteClick(Sender: TObject);
    procedure MFilmlistenClick(Sender: TObject);
    procedure MInfoDateienClick(Sender: TObject);
    procedure LiDaClick(Sender: TObject);
    procedure pnBiografieClick(Sender: TObject);
    procedure pnFilmografieClick(Sender: TObject);
    procedure LiDaDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure cbErwSucheClick(Sender: TObject);
    procedure MNurGeloeschteClick(Sender: TObject);
    procedure MMarker1Click(Sender: TObject);
    procedure MKeinMarkerClick(Sender: TObject);
    procedure buMarkereinblendungMouseEnter(Sender: TObject);
    procedure buMarkereinblendungMouseLeave(Sender: TObject);
    procedure buMarkereinblendungClick(Sender: TObject);
    procedure MGehezuCDNrClick(Sender: TObject);
    procedure pnTitelClick(Sender: TObject);
    procedure MMloeschen1Click(Sender: TObject);
    procedure MArchivumbenennenClick(Sender: TObject);
    procedure LaOrdnerDblClick(Sender: TObject);
    procedure MLWueberpruefenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    markerarr : array [1 .. 10] of Tcheckbox;
    kontinuierlich : boolean;
    letzte_datei : boolean;
    vom_code : boolean;
    spalte : integer;
    procedure akt;
    procedure breite_ermitteln;
    procedure gesamtbytes_anzeigen;
    procedure konvertieren;
    procedure neupos (id : integer);
    procedure marker_loeschen (LM : Byte);
    procedure recordcount_anzeigen;
    procedure suche;
  end;

var
  FHaupt: TFHaupt;

implementation

uses UFKorrigieren, UFInfo, UFDateilisten, UFDarsteller, UFBiografie,
  UFFilmografie, UFArchivUmbenennen, UFNeuerSpeicherort;

{$R *.lfm}


procedure TFHaupt.FormDropFiles(Sender: TObject; const FileNames: array of String);

var
     i, j,
     Anzahl,
     laenge, p  : integer;
     max, flags : dword;
     t : tsearchrec;
     gefunden, linux : boolean;
     gefundenid : integer;
     s, verzname, vname, v : string;
     query : tsqlquery;

begin
     // Feststellen, wieviele Files gedroppt werden
     anzahl := length (filenames);
     v := inttostr (anzahl) + #13;

     for  j := low (filenames) to high (filenames)
     do   v := v + filenames [j] + #10;
     showmessage (v);


     auto.modus := manuell;

     // Jeden Dateinamen einzeln ermitteln bei mehreren Files!
     // In diesem Fall wird nur die erste Datei unterstützt - eine .TXT, die alle Angaben zum Film enthält

     for i := 0 to anzahl - 1 do
     begin
          auto.modus := automatisch;
          s := filenames [i]; // s enthält den kompletten Namen, z. B. /media/laufwerksname/verzeichnisname

          // Verzeichnisnamen extrahieren (rückwärts bis zum /)
          vname := '';
          p := length (s);

          while (p > 0) and (s [p] <> '/') do
          begin
               vname := s [p] + vname;
               dec (p)
		end;

		auto.verzname := vname;

          // Laufwerksnamen extrahieren (rückwärts bis zum /)
          vname := '';
          dec (p);

          while (p > 0) and (s [p] <> '/') do
          begin
               vname := s [p] + vname;
               dec (p)
		end;

		auto.lwname := vname;
          gefundenid := 0;

          // Prüfen, ob es sich um ein Verzeichnis handelt - nur dann gültig!
          if   not (verz_exist (s)) then
          begin
               showmessage ('Nur Verzeichnisse können verarbeitet werden!');
               auto.modus := manuell;
               exit;
          end;

         // Hier das Eigentliche mit dem Dateinamen machen
         // In diesem Fall das automatische Hinzufügen ermöglichen!

         // Prüfen, ob ein Verzeichnis mit dieser Bezeichnung bereits in der DB vorhanden ist.
         // Falls ja, NICHT erneut aufnehmen (Doppelerfassung verhindern)
         query := tsqlquery.Create(nil);
         query.DataBase := sqlconn;
         query.SQL.add ('Select * from `titel` where `verz`=' + #39 + auto.verzname + #39);
         query.Open;
         gefunden := query.RecordCount > 0;

         if    gefunden
         then  showmessage ('Komplett = ' + s + #10
                         + 'Ordnername = ' + auto.verzname + #10
                         + 'Laufwerkname = ' + auto.lwname + #10
                         + 'Der Ordner wurde in der Datenbank gefunden!')
         else  showmessage ('Komplett = ' + s + #10
                         + 'Ordnername = ' + auto.verzname + #10
                         + 'Laufwerkname = ' + auto.lwname + #10
                         + 'Der ordner wurde NICHT in der Datenbank gefunden!');


(*
         if   gefunden then // Verzeichnis schon vorhanden - nicht erneut aufnehmen!
         begin
              gefundenid := query.FieldByName(id).asinteger;
              beep;
              showmessage ('Der Ordner ' + #13
                         + '»' + auto.verzname + '«' + #13
                         + 'existiert bereits in der Datenbank' + #13
                         + 'und ist dem Archiv »' + query.FieldByName(hdname) + '« zugewiesen!' + #13#13
                         + 'Die ID ist ' + inttostr (gefundenid));
         end else
         begin // Ordner in die Datenbank aufnehmen
              // TXT-Datei mit den Filminfos suchen
              auto.textdateiname := '';

              if   findfirst (s + '/*.TXT', faanyfile, t) = 0
              then auto.textdateiname := t.name
              else repeat
                   until findnext (t) <> 0;

              findclose (t);

              if   auto.textdateiname <> '' then
              begin
//                    showmessage (auto.textdateiname);
                   GetVolumeInformation (PChar (auto.LW + ':'), puffer, sizeof(puffer), nil, max, Flags, nil, 0);
                   auto.lwname := puffer;
                   auto.verzeichnis := dropname;
                   auto.verzeichnis := copy (auto.verzeichnis, 4, 255);
                   auto.textdateiname := auto.lw + ':\' + auto.verzeichnis + '\'+ auto.textdateiname;

                   // Laufwerksbezeichnung anzeigen
{                    ShowMessage ('LW: ' + auto.lw + #13
                              + 'LW-Name = ' + auto.lwname + #13
                              + 'Verzeichnis: = ' + auto.verzeichnis + #13
                              + 'Textdateiname: ' + auto.textdateiname);
}
                   letzte_datei := i = anzahl - 1;
                   buhinzufuegenclick (self);
              end else
              begin
                   showmessage ('Keine *.TXT-Datei im Verzeichnis ' + #13
                              + dropname + #13
                              + 'gefunden!');
                   beep;
              end;
         end;*)
     end;

     auto.modus := manuell;
end;

procedure TFHaupt.akt;

begin
     recordcount_anzeigen;
     gesamtbytes_anzeigen;
end;




procedure TFHaupt.breite_ermitteln;

var
     breite, j : integer;
     bm : timage;

begin // Ermittelt die Breite der Marker-Erklärungsbox sowie deren Position (zentriert)
     bm := timage.create (self);
     breite := 126; // Minimumbreite
     bm.width := 1000;
     bm.height := 100;
     bm.canvas.font.name := 'Courier New';
     bm.canvas.font.size := 12;

     for  j := 1 to 10
     do   if   bm.canvas.textwidth (us.markerbez [j]) > breite
          then breite := bm.canvas.textwidth (us.markerbez [j]);

     inc (breite, bm.canvas.textwidth (' 1 =  '));
     inc (breite, 20);

     if   breite > trunc (width * 0.8)
     then breite := trunc (width * 0.8);
     
     pnmarker.width := breite;
     bm.free;
end;




procedure TFHaupt.gesamtbytes_anzeigen;

var
     id, j : integer;
     gesamt : single;

begin
     if   qu.recordcount = 0
     then exit;
     
     gesamt := 0;
     id := qu.fieldbyname ('id').asinteger;
     qu.DisableControls;
     qu.first;

     while not (qu.EOF) do
     begin
          gesamt := gesamt + qu.fieldbyname ('groesse').asfloat;
          qu.next;
	end;

     qu.First;

     for  j := 0 to qu.recordcount
     do   if   qu.fieldbyname ('id').asinteger = id
          then break
          else qu.next;

     qu.EnableControls;
     lagesamtbytes.caption := 'Gesamt: ' + floattostrf (gesamt / 1024 / 1024 / 1024, ffnumber, 20, 2) + ' GB';
end;




procedure TFHaupt.konvertieren;

type
     tdarsteller = record
          name : string;
          id : integer;
	end;

var
     j, k, p : integer;
     qudarsteller, qukonv : tsqlquery;
     befehl,
     titel,
     datum,
     format,
     jahr,
     genre,
     bemerkung,
     info,
     hdname,
     verz,
     marker,
     h: string;
     darsteller : array of tdarsteller;
     dids : array of integer;
     geloescht, gesehen : boolean;
     max, id : integer;
     meinfo : tmemo;
     groesse : int64;
     gefunden : boolean;

     function parse (s : string) : string;

     var
          j : integer;
          h : string;

     begin
          h := '';

          for  j := 1 to length (s)
          do   if   s [j] = #39
               then h := h + '\' + #39
               else h := h + s [j];

          result := h;
     end;

begin
     assignfile (frec, progverz + 'FilmDB.dat');
     reset (frec);
     qukonv := tsqlquery.Create(nil);
     qukonv.DataBase := sqlconn;
     qudarsteller := tsqlquery.Create(nil);
     qudarsteller.DataBase := fhaupt.sqlconn;
     meinfo := tmemo.Create(self);
     max := filesize (frec);
     Application.CreateForm(TFKonvertierung, FKonvertierung);
     fkonvertierung.show;
     fkonvertierung.refresh;

     for  j := 1 to max do
     begin
          fkonvertierung.lainfo.caption := inttostr (j) + ' von ' + inttostr (max);
          fkonvertierung.lainfo.refresh;
          lesen (j);
          id := rec.ID;
          titel := ISO_8859_1ToUTF8 (parse (rec.titel));
          datum := formatdatetime ('yyyy-mm-dd', rec.datum);
          format := ISO_8859_1ToUTF8 (parse (rec.format));
          jahr := rec.jahr;
          genre := ISO_8859_1ToUTF8 (parse (rec.genre));
          bemerkung := ISO_8859_1ToUTF8 (parse (rec.bemerkung));
          geloescht := rec.geloescht;
          gesehen := rec.gesehen;
          info := ISO_8859_1ToUTF8 (parse (rec.info));
          groesse := rec.groesse;
          hdname := ISO_8859_1ToUTF8 (parse (rec.hdname));
          verz := ISO_8859_1ToUTF8 (parse (rec.verz));
          marker := '----------';

          for  k := 1 to 10 do // alle Marker setzen
          begin
               if   rec.marker [k]
               then marker [k] := 'x';
          end;

          meinfo.text := info;
          p := 0;

          for  k := 0 to meinfo.lines.Count - 1 do
          begin
               if   meinfo.lines [k] = 'Darsteller:'
               then break
               else inc (p);
          end;

          inc (p);
          setlength (darsteller, 0);

          while ((p < meinfo.lines.Count - 1) and (meinfo.lines [p] <> '')) do
          begin
               setlength (darsteller, length (darsteller) + 1);
               darsteller [high (darsteller)].name := meinfo.lines [p];
               inc (p);
          end;

          // Alle Darsteller dieses Films sind nun im Array
          // Prüfen, ob der Darsteller bereits in der Datenbank vorhanden ist
          // Falls nicht, hinzufügen und ID speichern
          // Falls doch, nur die ID speichern - dieses IDs müssen in die Verknüpfungstabelle eingetragen werden

          for  k := low (darsteller) to high (darsteller) do
          begin
               qudarsteller.close;
               qudarsteller.SQL.clear;
               h := 'Select * from darsteller where name = "' + darsteller [k].name + '"';
               qudarsteller.sql.Add (h);
               qudarsteller.open;
               p := qudarsteller.recordcount;

               if   qudarsteller.RecordCount = 0 then
               begin
                    qudarsteller.close;
                    qudarsteller.sql.clear;
                    h := 'INSERT INTO darsteller (id, name) VALUES (NULL , "' + darsteller [k].name + '")';
                    qudarsteller.sql.add (h);
               try
                    qudarsteller.ExecSQL;
               except
                    showmessage ('Doppelter Eintrag in der Darsteller-DB »' + darsteller [k].name + '«');
               end;
                    qudarsteller.close;
                    qudarsteller.sql.Clear;
                    h := 'Select * from darsteller where name = "' + darsteller [k].name + '"';
                    qudarsteller.sql.Add (h);
                    qudarsteller.open;
			end;

               p := qudarsteller.recordcount;
               darsteller [k].id := qudarsteller.FieldByName('id').AsInteger;
		end;
(*
          h := '';

          for  k := low (darsteller) to high (darsteller)
          do   h := h + inttostr (darsteller [k].id) + ' / ' + darsteller [k].name + #10;

          showmessage ('Die Darsteller-IDs sind (ID / Name):' + #10#10 + h);
*)
          qudarsteller.close;
          qudarsteller.sql.Clear;
          qudarsteller.sql.add ('Select * from tid where');

          qukonv.active := false;
          qukonv.sql.clear;

          befehl := 'INSERT INTO `FilmDB`.`titel` (`id`, `titel`, `datum`, `format`, `jahr`, `genre`, `bemerkung`, `geloescht`, ' +
                                '`info`, `groesse`, `gesehen`, `hdname`, `verz`, `marker`) ' +
                    'VALUES (NULL, ''' + titel + ''', ''' + datum + ''', ''' + format + ''' , ''' + jahr + ''', ''' +
                             genre + ''', ''' + bemerkung + ''', ''';

          if   geloescht
          then befehl := befehl + 'ja'
          else befehl := befehl + 'nein';

          befehl := befehl + ''', ''' + info + ''', ''' + inttostr (groesse) + ''', ''';

          if   gesehen
          then befehl := befehl + 'ja'
          else befehl := befehl + 'nein';

          befehl := befehl + ''', ''' + hdname + ''', ''' + verz + ''', ''' + marker+ ''')';
          qukonv.sql.Add (befehl);
//          showmessage (befehl);

          try
               // Film in Datenbank eintragen
               qukonv.execsql;

               // j enthält die ID des Films
               // Nun alle  Darsteller mit dem Film verknüpfen
               for  k := low (darsteller) to high (darsteller) do
               begin
                    qudarsteller.close;
                    qudarsteller.SQL.clear;
                    h := 'INSERT INTO dids (tid, did) VALUES (' + inttostr (j) + ', ' + inttostr (darsteller [k].id) + ')';
                    qudarsteller.sql.add (h);
                    qudarsteller.ExecSQL;
			end;
		except on e:exception do
                   begin
                     Showmessage('Fehler aufgetreten: ' + e.message);
                     raise;
                   end;
          end;
     end;

     closefile (frec);
     qukonv.Close;
     qukonv.Free;
     qu.active := false;
     qu.sql.clear;
     qu.sql.add ('select * from titel order by titel;');
     qu.active := true;
end;




procedure TFHaupt.neupos (id : integer);

begin with qu do
begin
     disablecontrols;
     close;
     open;
     First;

     while not EOF
     do   if   fieldbyname ('id').asinteger = id
          then break
          else next;

     enablecontrols;
end;
end;



procedure TFHaupt.marker_loeschen (LM : Byte); // LM = zu löschender Marker

var
     anz, j : integer;

begin (*
     beep;

     if   messagedlg ('Wollen Sie wirklich Marker ' + inttostr (LM) + ' löschen?' + #13
                   + 'Achtung: Dies läßt sich NICHT rückgängig machen!',
                   mtconfirmation, [mbyes, mbno], 0) = mrno
     then exit;

     anz := 0;

     for  j := 1 to recordcount do
     begin
          lesen (j);

          if   rec.Marker [LM] then
          begin
               rec.marker [LM] := false;
               schreiben (j);
               inc (anz);
          end;
     end;

     showmessage (inttostr (anz) + ' Marker gelöscht!'); *)
end;




procedure TFHaupt.recordcount_anzeigen;

begin
     caption := 'Hase Cäsars Filmverwaltung (Version 3.0) ';

//     showmessage (inttostr (qu.recordcount));

     if   qu.recordcount = 1
     then if   loeschanz = 1
          then caption := caption + '- 1 Film mit 1 Löschmarkierung'
          else caption := caption + '- 1 Film mit 0 Löschmarkierungen'
     else if   loeschanz = 1
          then caption := caption + '- ' + floattostrf (qu.recordcount, ffnumber, 10, 0) + ' Filme mit 1 Löschmarkierung'
          else caption := caption + '- ' + floattostrf (qu.recordcount, ffnumber, 10, 0) + ' Filme mit ' + inttostr (loeschanz) + ' Löschmarkierungen';

     if   nur_geloeschte
     then caption := caption + ' (nur geloeschte)';

     if   marker > 0
     then caption := caption + ' (nur Marker ' + inttostr (marker) + ')';

     bukorrigieren.enabled := qu.recordcount > 0;
     buloeschen   .enabled := qu.recordcount > 0;
     gesamtbytes_anzeigen;
end;

procedure TFHaupt .grmarkerDrawCell (Sender : TObject ; aCol , aRow : Integer ; aRect : TRect ; aState : TGridDrawState );

var
     h : string;
     altfarbe, farbe : integer;
     b : integer;

begin
     h := qu.FieldByName('marker').asstring;

     if   h = ''
     then exit;

     farbe := clbtnface;

     if   h [acol + 1] = 'x'
     then farbe := rot;

     altfarbe := grmarker.color;
     grmarker.Color := farbe;
     grmarker.canvas.Brush.color := farbe;
     grmarker.canvas.pen.style := psclear;
     grmarker.Canvas.Rectangle (arect.Left, arect.top, arect.Right, arect.Bottom);
     b := (arect.Right - arect.left) div 2;
     grmarker.canvas.TextOut(arect.left + b, arect.Top + 4, inttostr (acol + 1));
     grmarker.color := altfarbe;
end;

procedure TFHaupt .grmarkerResize (Sender : TObject );

var
     j : integer;

begin
     for  j := 0 to 9
     do   grmarker.ColWidths [j] := (grmarker.width - 1) div 10;
end;

procedure TFHaupt .grmarkerSelection (Sender : TObject ; aCol , aRow : Integer );

var
     id : integer;
     h, s : string;

begin
     id := qu.FieldByName('id').asinteger;
     h := qu.FieldByName('marker').asstring;
     spalte := acol + 1;

     // Marker setzen bzw. aufheben (Toggle)
     if   h [spalte] = 'x'
     then h [spalte] := '-'
     else h [spalte] := 'x';

     with quupdate do
     begin
          active := false;
          sql.clear;
          s := 'UPDATE `titel` SET `marker`=' + #39 + h + #39 + ' WHERE id = ' + inttostr (id);
          SQL.Add (s);
     	try
               execsql;
     	finally
               active := false;
     	end;
	end;

     neupos (id);
end;




procedure TFHaupt.suche;

var
     j : integer;

begin (*
     for  j := 1 to pred (g.rowcount) do
     begin
          if   pos (sb, tsuppercase (g.cells [6, j])) = 1 then
          begin
               g.row := j;
               break;
          end;
     end; *)
end;




procedure TFHaupt.buDateiausgabeClick(Sender: TObject);

var
     abbruch, gewuenscht : boolean;
     t : textfile;
     alter_index : byte;
     format : string;
     anz, j, k : integer;
     datum : tdatetime;
     dateiname, n : ansistring;

begin (*
     application.createform (tfdateilisten, fdateilisten);
     fdateilisten.showmodal;

     abbruch := fdateilisten.modalresult = mrcancel;
     fdateilisten.free;

     if   abbruch
     then exit;

     datum := now;
     alter_index := lisort.itemindex;
     sanduhr1;

     for  j := 1 to pred (lisort.items.count) do
     begin
          gewuenscht := false;

          case j of
               1 : gewuenscht := us.listen.titel;
               2 : gewuenscht := us.listen.genre;
               3 : gewuenscht := us.listen.jahr;
               4 : gewuenscht := us.listen.format;
               5 : gewuenscht := us.listen.datum;
               6 : gewuenscht := us.listen.cdnr;
          end;

          if   gewuenscht then
          begin
               lisort.itemindex := j;
               lisortchange (self);
               n := us.listen.verz + '!_!_!_' + us.listen.dateiname;

               if   us.listen.stempel
               then n := n + ' vom ' + formatdatetime ('DD.MM.YYYY - HH-NN', datum);

               n := n + ' (sortiert nach ' + lisort.items [j];

               if   us.listen.detail
               then n := n + ' - detailliert).txt'
               else n := n + ').TXT';

               dateiname := n;
               assignfile (t, dateiname);
               rewrite (t);

               anz := 0;
               writeln (t, 'DVD-Nr.  Format     Jahr   Datum      Titel');
               //          '123456789 123456789 123456789 123456789'

               if   us.listen.detail
               then writeln (t, '                                            [Genre] / Bemerkung');

               writeln (t, '------------------------------------------------------------------------------------------------');

               for  k := 1 to g.rowcount - 1 do
               begin
                    lesen (strtoint (g.cells [0, k]));
                    inc (anz);
                    n := rec.HDName;

                    while length (n) < 6
                    do   n := ' ' + n;

                    n := n + '   ';

                    if   rec.infosize = 0
                    then n := 'x' + copy (n, 2, pred (length (n)));

                    format := rec.format;

                    while length (format) < 15
                    do   format := format + ' ';

                    if   rec.jahr  = '0'
                    then rec.jahr := '';

                    n := n + rec.Jahr;

                    while length (n) < 33
                    do   n := n + ' ';

                    n := n + formatdatetime ('DD.MM.YY', rec.datum);

                    while length (n) < 44
                    do   n := n + ' ';

                    n := n + rec.Titel;
                    writeln (t, n);

                    if   us.listen.detail then
                    begin
                         n := '';

                         if   rec.genre <> ''
                         then n := n + '[' + rec.genre + ']';

                         if   (length (n) > 0)
                         and  (length (rec.bemerkung) > 0)
                         then n := n + ' / ';

                         n := n + rec.bemerkung;
                         writeln (t, n);
                         writeln (t, '------------------------------------------------------------------------------------------------');
                    end;
               end;


               writeln (t);
               writeln (t, 'Titelanzahl: ' + floattostrf (anz, ffnumber, 10, 0));

               closefile (t);
          end;
     end;

     lisort.itemindex := alter_index;
     lisortchange (self);
     sanduhr0;
     beep;
     showmessage ('Filmliste(n) erstellt. Datei(en) sind im Ordner: ' + us.listen.verz); *)
end;

procedure TFHaupt.buHinzufuegenClick(Sender: TObject);

var
     neue_id, pos, j : integer;          // Veraltet - wird über drag und drop gelöst
     abgebrochen : boolean;

begin
(*
	sql.Clear;
	sql.Add('select max(id) from titel');
	sql.open;
	id := fieldbyname ('id').asinteger;
	quupdate.close;
	sql.clear;

     application.CreateForm (TFKorrigieren, FKorrigieren);
     funktion := ff_hinzufuegen;
     FKorrigieren.showmodal;
     abgebrochen := FKorrigieren.modalresult = mrcancel;
     pos := 0;

     if   not abgebrochen then
     if   (auto.modus = manuell) or ((auto.modus = automatisch) and letzte_datei) then
     begin
          closefile (frec);
          reset (frec);
          neue_id := fhinzufuegen.id;

          for  j := 1 to pred (g.rowcount) do
          begin
               if   strtoint (g.cells [0, j]) = neue_id then
               begin
                    pos := j;
                    break;
               end;
          end;

          g.row := pos;
          sicherung_notwendig := true;
     end;

     FKorrigieren.free; *)
end;

procedure TFHaupt.buKorrigierenClick(Sender: TObject);

var
     abgebrochen : boolean;
     korrektur_id : integer;
     s : string;

begin
     FKorrigieren := TFKorrigieren.Create(self);
try {
     FKorrigieren.Caption := 'Film-Info für ' + qu.FieldByName('titel').asstring + ' (Esc zum Schließen)';
     FKorrigieren.teHDName.text := qu.fieldbyname ('hdname').asstring;
     FKorrigieren.tedatum.text := qu.fieldbyname ('datum').asstring;
     FKorrigieren.tejahr.text := qu.fieldbyname ('jahr').asstring;
     FKorrigieren.liformat.itemindex := FKorrigieren.liformat.Items.IndexOf (qu.FieldByName('format').asstring);
     FKorrigieren.tetitel.text := qu.fieldbyname ('titel').asstring;
     FKorrigieren.tebemerkung.text := qu.fieldbyname ('bemerkung').asstring;
     FKorrigieren.tegenre.text := qu.fieldbyname ('genre').asstring;
     FKorrigieren.meinfo.text := qu.FieldByName('info').asstring; }
     abgebrochen := (FKorrigieren.showmodal <> mrOK);         // *** HIER LIEGT DAS PROBLEM, DIE NÄCHSTE ZEILE WIRD NACH DEM SCHLIESSEN NICHT AUSGEFÜHRT - ABER BEI PROGRAMMENDE !

     if   abgebrochen then
     begin
          FKorrigieren.free;
          exit;
     end;
     showmessage ('Erste Zeile nach showmodal');
     // Daten wurden bereits auf Gültigkeit im FKorrigieren geprüft - alles ok
     // Datensatz updaten
{     with FKorrigieren do
     begin
          s := 'UPDATE `titel`, `datum`, `format`, `jahr`, `genre`, `bemerkung`, `info`, `hdname`,  ' +
               'VALUES (' +
          #39 + tetitel.text + #39 +
          #39 + dbdatum (tedatum.text) + #39 +
          #39 + liformat.items [liformat.ItemIndex] + #39 +
          #39 + trim (tejahr.text) + #39 +
          #39 + trim (tegenre.text) + #39 +
          #39 + trim (tebemerkung.text) + #39 +
          #39 + meinfo.text + #39 +
          #39 + trim (tehdname.text) + #39 +
          ') where `id` = ' + inttostr (korrektur_id);
     end;

     with quupdate do
     begin
         close;
         sql.clear;
         sql.add('s');
         try
              execsql;
	    except
              showmessage ('Datensatz konnte nicht aktualisiert werden!');
	    end;
	end;

     neupos (korrektur_id);
     sicherung_notwendig := true;}
finally
     FKorrigieren.free;
     FKorrigieren := NIL;
end;
end;

procedure TFHaupt.GDblClick(Sender: TObject);
begin
     if   qu.recordcount > 0
     then bukorrigierenclick (self);
end;

procedure TFHaupt.Timer1Timer(Sender: TObject);
begin
     timer1.enabled := false;
     laposinfo.caption := '';
end;

procedure TFHaupt.tiSBTimer(Sender: TObject);
begin
     tisb.enabled := false;
     laposinfo.caption := '';
     laposinfo.Visible := false;
     sb := '';
end;

procedure TFHaupt.GKeyPress(Sender: TObject; var Key: Char);
begin
     tisb.enabled := false;

     if   (key = #8)
     then if   (length (sb) > 0)
          then setlength (sb, pred (length (sb)))
          else
     else sb := sb + key;

     sb := tsuppercase (sb);
     laposinfo.caption := ' ' + sb;
     laposinfo.Visible := true;
     tisb.enabled := true;
     suche;
end;

procedure TFHaupt.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

var
     pos : byte;

begin
     if   key = vk_f2
     then bukorrigierenclick (self);

     if   (key = vk_f4)
     and  (shift = [])
     then buloeschenclick (self);

     if   key = vk_f5
     then budateiausgabeclick (self);

     if   key = vk_f6
     then butxtclick (self);

     if   key = vk_f7
     then if   buinfo.visible
          then buinfoclick (self);

     if   (key = ord ('R'))
     and  (shift = [ssalt]) then
     begin
          lida.setfocus;
          lida.droppeddown := true;
     end;

     if   (key in [ord ('0') .. ord ('9')])
     and  (shift = [ssctrl])
     and  (qu.recordcount > 0)
     then ;//cbmarker.Checked [ord (key)] := not cbmarker.Checked [ord (key)];
end;

procedure TFHaupt.buLoeschenClick(Sender: TObject);

var
     id : integer;

begin
     id := qu.FieldByName('id').asinteger;

     if   qu.FieldByName('geloescht').AsBoolean
     then dec (loeschanz)
     else inc (loeschanz);

     qu.FieldByName('geloescht').asboolean := not qu.fieldbyname('geloescht').asboolean;
     dbg.refresh;
     recordcount_anzeigen;
end;

procedure TFHaupt.buTXTClick(Sender: TObject);

var
     v, n, h : ansistring;
     k : integer;
     f : textfile;

begin // TXT-Datei erstellen
(*
     v := progverz;

     lesen (strtoint (g.cells [0, g.row]));

     n := n + rec.titel;

     if   rec.jahr > '0'
     then n := n + ' (' + rec.jahr + ')';

     n := n + '.txt';

     // Ungültige Zeichen entfernen
     h := '';

     for  k := 1 to length (n) do
     begin
          case n [k] of
               '\',
               '/',
               ':',
               '*',
               '?',
               '<',
               '>',
               '|' : h := h + '-';
               '"' : h := h + '''';
               else h := h + n [k];
          end;
     end;


     n := h;
     v := v + n;
     assignfile (f, v);
     rewrite (f);
     write (f, rec.info);
     closefile (f);

     showmessage ('Infodatei wurde gespeichert in: ' + v);
*)
end;

procedure TFHaupt.GDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);

var
     b : integer;
     h : ansistring;

begin
     if   qu.recordcount = 0
     then exit;
     (*
     if   spalte = acol
     then g.canvas.font.style := [fsbold]
     else g.canvas.font.style := [];

     case acol of
          0 :  begin
                    h := g.cells [acol, arow];
                    b := rect.right - rect.left;
                    b := b - g.canvas.textwidth (h) - 4;
                    g.canvas.rectangle (rect);
                    g.canvas.textout (rect.left + b, rect.top + 2, h);

                    if   arow > 0 then
                    begin
                         lesen (strtoint (g.cells [0, arow]));

                         // Ist Löschmarkierung gesetzt? Dann roter Kreis
                         if   rec.Geloescht then
                         begin
                              g.canvas.brush.color := clred;
                              g.canvas.ellipse (rect.left + 2, rect.top + 2, rect.left + 20, rect.top + 20);
                         end;

                         if   rec.geloescht then
                         begin
                              g.canvas.brush.color := clred;
                              g.canvas.ellipse (rect.left + 2, rect.top + 2, rect.left + 20, rect.top + 20);
                         end;

                         if   (arow = g.row)
                         then if  rec.geloescht
                              then buloeschen.caption := 'Wiederherst. (F4)'
                              else buloeschen.caption := 'Löschen (F4)';

                         // Wurde der Film schon gesehen? Dann blauer Kreis
                         if   rec.gesehen then
                         begin
                              g.canvas.brush.color := blau;
                              g.canvas.ellipse (rect.left + 21, rect.top + 6, rect.left + 30, rect.top + 15);
                         end;
                    end;
               end;
          1,
          2,
          5,
          6 :  begin
                    h := g.cells [acol, arow];
                    g.canvas.textout (rect.left + 2, rect.top + 2, h);
               end;
          3,
          4 :  begin
                    h := g.cells [acol, arow];
                    b := rect.right - rect.left;
                    b := (b - g.canvas.textwidth (h)) div 2;
                    g.canvas.pen.style := psclear;
                    g.canvas.rectangle (rect);
                    g.canvas.pen.style := pssolid;

                    if   (acol = 4)
                    and  (h = '0')
                    then h := '';

                    g.canvas.textout (rect.left + b, rect.top + 2, h);
               end;
     end;

     if   arow = 0
     then exit;

     if   arow = g.row then
     begin
          lesen (strtoint (g.cells [0, arow]));
          tebemerkung.text := trim (rec.Bemerkung);

          if   tebemerkung.text = ''
          then tebemerkung.color := hellgrau
          else tebemerkung.color := rot;

          vom_code := true;
          cbMarker1 .checked := rec.Marker [ 1];
          cbMarker2 .checked := rec.Marker [ 2];
          cbMarker3 .checked := rec.Marker [ 3];
          cbMarker4 .checked := rec.Marker [ 4];
          cbMarker5 .checked := rec.Marker [ 5];
          cbMarker6 .checked := rec.Marker [ 6];
          cbMarker7 .checked := rec.Marker [ 7];
          cbMarker8 .checked := rec.Marker [ 8];
          cbMarker9 .checked := rec.Marker [ 9];
          cbMarker10.checked := rec.Marker [10];
          vom_code := false;
          lagroesse.caption := 'Größe: ' + floattostrf (rec.groesse, ffnumber, 15, 0)
                             + ' (' + floattostrf (rec.groesse / (1024 * 1024 * 1024), ffnumber, 15, 2) + ' GB)';
          laordner.caption := 'Ort: ' + rec.verz;
          buinfo.visible := rec.Infosize > 0;
          leuchten;
     end;
     *)
end;

procedure TFHaupt.GSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
begin (*
     if   vom_code
     then exit;

     canselect := true;

     if   arow = 0 then showmessage ('bingo');
     try
          lesen (strtoint (g.cells [0, arow]));
     except
     end;

     if  rec.geloescht
     then buloeschen.caption := 'Wiederherst. (F4)'
     else buloeschen.caption := 'Löschen (F4)';

     Darsteller_aufbereiten (rec.darsteller, lida.items);
     lida.itemindex := 0;

     if   lida.items.count > 0
     then lidaclick (self); *)
end;

procedure TFHaupt.teSBKeyPress(Sender: TObject; var Key: Char);
begin
     if   key = #13 then
     begin
          key := #0;
          sb := trim (tsuppercase (tesb.text));
     end;
end;

procedure TFHaupt.buInfoClick(Sender: TObject);
begin
     application.createform (TFInfo, FInfo);

     with finfo do
     begin
		 finfo.Caption := 'Film-Info für ' + qu.FieldByName('titel').asstring + ' (Esc zum Schließen)';
	      finfo.meinfo.text := qu.FieldByName('info').asstring;
           showmessage (inttostr (length (finfo.meinfo.text)) + #10 + inttostr (length (qu.FieldByName('info').asstring)));
	      finfo.showmodal;
	end;
     finfo.free;
end;

procedure TFHaupt.MBeendenClick(Sender: TObject);
begin
     close;
end;

procedure TFHaupt.MLoeschenClick(Sender: TObject);
begin
     buloeschenclick (self);
end;

procedure TFHaupt.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
     us.HFVollbild := windowstate = wsmaximized;
     windowstate := wsnormal;
     us.HFPos := boundsrect;
end;

procedure TFHaupt.FormShow(Sender: TObject);

var
     j : integer;

begin
     for  j := 1 to 10
     do grmarker.Cells [j - 1, 0] := inttostr (j);

     qu.active := false;
     qu.active := true;
     boundsrect := us.HFPos;
     laposinfo.left  := tesb.left;
     laposinfo.width := tesb.width;

     qu.execsql;

     if   us.HFVollbild
     then windowstate := wsmaximized;

     pntitel.caption := us.ProgTitel;
     recordcount_anzeigen;

// showmessage ('Datensatzgröße: ' + inttostr (sizeof (recs)));

     // Prüfen, ob eine Konvertierung nötig ist (alte Datenbank in SQL-DB schreiben)

     if   (fileexists (progverz + 'FilmDB.dat')) then // Konvertierung erforderlich
     begin
          konvertieren;
     end;
end;

procedure TFHaupt.MDatensicherungClick(Sender: TObject);
begin
     us.datensicherung := not us.datensicherung;
end;

procedure TFHaupt.MSichern_in_OrdnerClick(Sender: TObject);

var
     dir : string;

begin (*
     dir := us.Sicherungsverz;

     if   not selectdirectory (dir, [], 0)
     then exit;

     us.sicherungsverz := verz_mit_slash (dir); *)
end;

procedure TFHaupt.MDateiClick(Sender: TObject);
begin
     mdatensicherung.checked := us.datensicherung;
end;

procedure TFHaupt.MMarkierte_loeschenClick(Sender: TObject);

var
     neu : file of trecs;
     anz, j : integer;

begin (*
     beep;

     if   loeschanz = 0 then
     begin
          showmessage ('Es sind keine Filme als gelöscht markiert!');
          exit;
     end;

     if   messagedlg ('Warnung! Dieser Vorgang läßt sich NICHT rückgängig machen!'
                    + #13
                    + 'Möchten Sie fortsetzen?',
                      mtconfirmation, [mbyes, mbno], 0) = mrno
     then exit;

     if   messagedlg ('Zu Ihrer Sicherheit frage ich lieber nochmal nach!'
                    + #13
                    + 'Sind Sie sicher, daß Sie fortsetzen möchten?',
                      mtconfirmation, [mbyes, mbno], 0) = mrno
     then exit;

     sanduhr1;
     assignfile (neu, dbname + '.neu');
     rewrite (neu);
     anz := 0;

     for  j := 1 to filesize (frec) do
     begin
          lesen (j);

          if   not rec.Geloescht then
          begin
               inc (anz);
               recs.ID := anz;
               write (neu, recs);
          end;
     end;

     closefile (neu);
     closefile (frec);
     deletefile (dbname);
     renamefile (dbname + '.neu', dbname);
     reset (frec);

     sicherung_notwendig := true;
     sanduhr0; *)
end;

procedure TFHaupt.MDaten_importierenClick(Sender: TObject);

var
     neu : string;
     f : file of trecs;
     j : integer;

begin (*
     if   not od.execute
     then exit;

     neu := od.FileName;
     assignfile (f, neu);
     reset (f);

     for  j := 0 to filesize (f) - 1 do
     begin
          read (f, recs);
          recs.ID := succ (filesize (frec));
          seek (frec, pred (recs.id));
          write (frec, recs);
     end;

     closefile (f);
     closefile (frec);
     reset (frec); *)
end;

procedure TFHaupt.MDaten_exportierenClick(Sender: TObject);

var
     neu : string;
     f : file of trecs;
     anz, j : integer;

begin (*
     if   not sd.execute
     then exit;

     neu := sd.FileName;
     assignfile (f, neu);
     rewrite (f);
     anz := 0;

     for  j := 1 to g.rowcount - 1 do
     begin
          lesen (strtoint (g.cells [0, j]));
          inc (anz);
          recs.ID := anz;
          write (f, recs);
     end;

     closefile (f); *)
end;

procedure TFHaupt.GMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

var
     acol, arow : integer;

begin
     if   shift = [ssshift, ssctrl, ssleft] then
     begin
          qu.fieldbyname ('gesehen').asboolean := not qu.FieldByName('gesehen').asboolean;
          dbg.refresh;
     end;
end;

procedure TFHaupt.MGesehenzaehlenClick(Sender: TObject);

var
     j, ges : integer;

begin (*
     ges := 0;

     for  j := 1 to recordcount do
     begin
          lesen (j);

          if   rec.gesehen
          then inc (ges);
     end;

     showmessage (inttostr (ges)); *)
end;

procedure TFHaupt.MDarstellerlisteClick(Sender: TObject);
begin
     FDarsteller.show;
end;

procedure TFHaupt.MFilmlistenClick(Sender: TObject);
begin
     buDateiausgabeclick (self);
end;

procedure TFHaupt.MInfoDateienClick(Sender: TObject);
begin
     butxtclick (self);
end;

procedure TFHaupt.LiDaClick(Sender: TObject);
begin
     if   biografie_vorhanden (lida.items [lida.itemindex])
     then pnbiografie.font.color := schwarz
     else pnbiografie.font.color := rot;

     if   filmografie_vorhanden (lida.items [lida.itemindex])
     then pnfilmografie.font.color := schwarz
     else pnfilmografie.font.color := rot;
end;

procedure TFHaupt.pnBiografieClick(Sender: TObject);

var
     pos : integer;

begin  (*
     if   lida.items.count = 0
     then exit;

     application.createform (TFBiografie, FBiografie);
     pos := lida.itemindex;
     FBiografie.darsteller := lida.items [lida.itemindex];
     FBiografie.showmodal;
     FBiografie.free;
     lida.itemindex := pos;
     lidaclick (self); *)
end;

procedure TFHaupt.pnFilmografieClick(Sender: TObject);
begin (*
     if   lida.items.count = 0
     then exit;

     application.createform (TFFilmografie, FFilmografie);

     if   FFilmografie.lida.items.IndexOf (lida.items [lida.itemindex]) = -1
     then FFilmografie.lida.items.Add (lida.items [lida.itemindex]);

     FFilmografie.lida.itemindex := FFilmografie.lida.items.indexof (lida.items [lida.itemindex]);
     FFilmografie.lidaclick (self);

     FFilmografie.showmodal;
     FFilmografie.free;
     lidaclick (self); *)
end;

procedure TFHaupt.LiDaDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);

var
     alte_farbe : tcolor;
     r : trect;

begin (*
     lida.Canvas.Pen.style := psclear;

     if   biografie_vorhanden (lida.items [index]) then
     begin
          r := rect;
          dec (r.top);
          inc (r.bottom);
          r.Right := r.right div 2;
          alte_farbe := lida.Canvas.brush.color;
          lida.Canvas.brush.color := pastellgruen;
          lida.canvas.Rectangle (r);
          lida.canvas.brush.color := alte_farbe;
     end;

     if   filmografie_vorhanden (lida.items [index]) then
     begin
          r := rect;
          dec (r.top);
          inc (r.bottom);
          r.left := r.left + ((r.right - r.left) div 2);
          alte_farbe := lida.Canvas.brush.color;
          lida.Canvas.brush.color := pastellgruen;
          lida.canvas.Rectangle (r);
          lida.canvas.brush.color := alte_farbe;
     end;

     if   bild_vorhanden (lida.items [index]) then
     begin
          r := rect;
          dec (r.top);
          inc (r.bottom);
          r.left := r.right - 30;
          r.right := r.right - 10;
          alte_farbe := lida.Canvas.brush.color;
          lida.Canvas.brush.color := rot;
          lida.canvas.Rectangle (r);
          lida.canvas.brush.color := alte_farbe;
          lida.canvas.font.style := [fsbold];
          lida.canvas.font.color := weiss;
          lida.canvas.Brush.style := bsclear;
          lida.Canvas.TextOut (r.left + 5, rect.top, 'F');
          lida.canvas.font.style := [];
          lida.canvas.font.color := schwarz;
     end;

     lida.Canvas.brush.Style := bsclear;

     if   state <> []
     then lida.canvas.Font.color := rot
     else lida.canvas.Font.color := schwarz;
     
     lida.Canvas.textout (rect.left, rect.top, lida.items [index]); *)
end;

procedure TFHaupt.cbErwSucheClick(Sender: TObject);
begin
     erweiterte_suche := cberwsuche.checked;
end;

procedure TFHaupt.MNurGeloeschteClick(Sender: TObject);
begin (*
     nur_geloeschte := not nur_geloeschte;
     MNurgeloeschte.checked := nur_geloeschte;

     if   g.visible
     then g.setfocus; *)
end;

procedure TFHaupt.MMarker1Click(Sender: TObject);

var
     k : integer;
     
begin (*
     for  k := 0 to pred (componentcount)
     do   if   components [k] is TMenuItem
          then if   tmenuitem (components [k]).name = 'MMarker' + inttostr (tmenuitem (sender).tag)
               then tmenuitem (components [k]).checked := true;

     Marker := tmenuitem (sender).tag;
     MKeinMarker.checked := false;
     MAktMarker.caption := 'Marker ' + inttostr (marker);
     
     if   g.visible
     then g.setfocus; *)
end;

procedure TFHaupt.MKeinMarkerClick(Sender: TObject);

var
     j, k : integer;

begin (*
     if   marker = 0
     then exit;

     for  j := 1 to 10 do
     for  k := 0 to pred (componentcount)
     do   if   components [k] is TMenuItem
          then if   tmenuitem (components [k]).name = 'MMarker' + inttostr (j)
               then tmenuitem (components [k]).checked := false;

     marker := 0;
     MKeinMarker.checked := true;
     MAktMarker.caption := 'Marker';

     if   g.visible
     then g.setfocus; *)
end;

procedure TFHaupt .dbGTitleClick (Column : TColumn );

var
     j, id : integer;
     sort : string;

begin
     id := qu.FieldByName('id').asinteger;
     sort := column.FieldName;
     qu.close;
     qu.SQL.clear;

     if   sort = 'titel'
     then qu.sql.add ('select * from titel order by ' + sort)
     else qu.sql.add ('Select * from titel order by ' + sort + ', titel');

     qu.open;
     qu.disablecontrols;

     for  j := 0 to dbg.Columns.Count - 1
     do   dbg.columns [j].title.Font.Style := [];

     column.title.Font.Style := [fsbold];

     while not qu.EOF
     do   if   qu.FieldByName('id').asinteger = id
          then break
          else qu.Next;

     qu.EnableControls;
end;

procedure TFHaupt.dsDataChange (Sender : TObject ; Field : TField );

var
     h : string;
     j, k : integer;

begin
     qudarst.Close;
     qudarst.SQL.Clear;
     h := 'select name from darsteller where id in (select did from dids where tid = ' + qu.FieldByName('id').asstring + ') order by name';
     qudarst.SQL.Add (h);
     qudarst.open;
//     showmessage (inttostr (qudarst.RecordCount) + #10 + h);

     if   qudarst.RecordCount > 0 then
     begin
	      qudarst.First;
		 liDa.Clear;

           while not qudarst.EOF do
           begin
               liDa.Items.Add(qudarst.FieldByName('name').asstring);
               qudarst.next;
		 end;

           liDa.itemindex := 0;
	end;

     lagroesse.caption := floattostrf (qu.FieldByName('groesse').asfloat, ffnumber, 12, 0) + '   (' +
                          floattostrf (qu.fieldbyname('groesse').asfloat / (1024 * 1024 * 1024), ffnumber, 12, 2)+ ' GB)';
     laordner.Caption := 'Ort: ' + qu.FieldByName('verz').asstring;

     h := qu.FieldByName('bemerkung').asstring;
     tebemerkung.text := h;

     if   h = ''
     then tebemerkung.Color := clbtnface
     else tebemerkung.color := rot;
end;

procedure TFHaupt.buMarkereinblendungMouseEnter(Sender: TObject);

var
     b, j : integer;

begin // Einblenden des Marker-Erklärungsfensters
     if   pnmarker.visible = false then
     begin
          limarker.items.clear;

          for  j := 1 to 10
          do   limarker.items.add (' ' + inttostr (j) + ' = ' + us.markerbez [j]);

          limarker.items [9] := copy (limarker.items [9], 2, 255);
     end;

     breite_ermitteln;
     b := (width - pnmarker.width) div 2;
     pnmarker.left := b;
     pnMarker.visible := true;
end;

procedure TFHaupt.buMarkereinblendungMouseLeave(Sender: TObject);
begin
     pnmarker.visible := false;
end;

procedure TFHaupt.buMarkereinblendungClick(Sender: TObject);
begin
     application.createform (TFMarker, FMarker);
     FMarker.showmodal;
     FMarker.free;
end;

procedure TFHaupt.MGehezuCDNrClick(Sender: TObject);

var
     cdnr : ansistring;
     j : integer;

begin (*
     cdnr := '';

     if   not inputquery ('Gehe zu CD-Nr.', 'Bitte CD-Nr. eingeben', cdnr)
     then exit;

     cdnr := trim (cdnr);

     for  j := 1 to pred (g.rowcount)
     do   if   pos (cdnr, g.Cells [1, j]) = 1 then
          begin
               g.Row := j;
               break;
          end; *)
end;

procedure TFHaupt.pnTitelClick(Sender: TObject);
begin
     pntitel.caption := inputbox ('Neuer Programmtitel', 'Bitte neuen Programmtitel eingeben!', pntitel.caption);
     us.progtitel := pntitel.caption;
end;

procedure TFHaupt.MMloeschen1Click(Sender: TObject);
begin
     Marker_loeschen (tmenuitem (sender).tag);
end;

procedure TFHaupt.MArchivumbenennenClick(Sender: TObject);

var
     j, pos : integer;

begin (*
     pos := strtoint (g.cells [0, g.Row]);
     application.CreateForm (tfarchivumbenennen, farchivumbenennen);
     farchivumbenennen.showmodal;
     farchivumbenennen.Free;

     for  j := 1 to g.RowCount
     do   if   g.cells [0, j] = inttostr (pos) then
          begin
               g.row := j;
               exit;
          end; *)
end;

procedure TFHaupt.LaOrdnerDblClick(Sender: TObject);
begin (*
     application.createform (TFNeuerSpeicherort, FNeuerSpeicherort);
     FNeuerSpeicherort.id := strtoint (g.cells [0, g.Row]);
     FNeuerSpeicherort.showmodal;
     FneuerSpeicherort.free; *)
end;

procedure TFHaupt.MLWueberpruefenClick(Sender: TObject);
begin
     // Prüft alle Ordnereinträge eines Laufwerks und
     // und vergleicht diese mit den Datenbankeinträgen
     // sowie umgekehrt: prüft Datenbankeinträge und das
     // Vorhandensein des Films auf dem Laufwerk
(*
     Application.CreateForm (TFLWCheck, FLWCheck);
     FLWCheck.showmodal;
     FLWCheck.free;
*)
end;

end.

