unit UFNeueFilmografie;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFNeueFilmografie = class(TForm)
    Panel1: TPanel;
    Memo: TMemo;
    buOK: TButton;
    buAbbruch: TButton;
    procedure FormShow(Sender: TObject);
    procedure buAbbruchClick(Sender: TObject);
    procedure buOKClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    schliessen_erlaubt : boolean;
  end;

var
  FNeueFilmografie: TFNeueFilmografie;

implementation

{$R *.lfm}

procedure TFNeueFilmografie.FormShow(Sender: TObject);

var
     t : tstringlist;
     j, p : integer;
     h : ansistring;

begin
     memo.PasteFromClipboard;
     schliessen_erlaubt := false;
     t := tstringlist.create;

     for  j := 0 to pred (memo.Lines.Count)
     do   t.add (memo.lines [j]);

     // Alle lfd. Nr. eliminieren

     for  j := 0 to pred (t.Count) do
     begin
          h := t [j];

          while (h [1]) <> ' '
          do   h := copy (h, 2, length (h) - 1);

          h := copy (h, 2, length (h) - 1);

          // Besonderheiten bei , Der - , Die - , Das
          p := pos (', Der', h);

          if   p > 0 then
          begin
               h := 'Der ' + copy (h, 1, pred (p)) + copy (h, p + 5, 255);
          end;

          p := pos (', Die', h);

          if   p > 0 then
          begin
               h := 'Die ' + copy (h, 1, pred (p)) + copy (h, p + 5, 255);
          end;

          p := pos (', Das', h);

          if   p > 0 then
          begin
               h := 'Das ' + copy (h, 1, pred (p)) + copy (h, p + 5, 255);
          end;

          t [j] := h;
     end;

     // Rückwärts sortieren, damit der älteste Film oben steht
     memo.clear;

     for  j := pred (t.count) downto 0
     do   memo.Lines.Add (t [j]);

     t.free;
end;

procedure TFNeueFilmografie.buAbbruchClick(Sender: TObject);
begin
     schliessen_erlaubt := true;
     modalresult := mrcancel; 
end;

procedure TFNeueFilmografie.buOKClick(Sender: TObject);
begin
     schliessen_erlaubt := true;
     modalresult := mrok;
end;

procedure TFNeueFilmografie.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
     canclose := schliessen_erlaubt;
end;

end.

