unit UFInfo;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, LCLType,
  StdCtrls, GLOBAl;

type
  TFInfo = class(TForm)
    meinfo: TMemo;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FInfo: TFInfo;

implementation

{$R *.lfm}

procedure TFInfo.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
     if   key = vk_escape
     then close;

     if   (shift = [ssctrl])
     and  (key = 65)
     then meinfo.selectall;
end;

procedure TFInfo.FormShow(Sender: TObject);
begin
     boundsrect := us.IFPos;

     if   us.IFVollbild
     then windowstate := wsmaximized;
end;

procedure TFInfo.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
     us.IFVollbild := windowstate = wsmaximized;
     windowstate := wsnormal;
     us.IFPos := boundsrect;
end;

end.
